#region << Using Directives >>
using System;
#endregion
namespace Volpe.Cafe.Model
{
    [Serializable]
    [ModelDescription("Maximum Technology Compliance Model", "Runs a standard compliance model, using assumptions required " +
         "for \"maximum technology\" modeling.", 1.0F)]
    public class MaxTechCompliance : Compliance
	{
        #region 
        public MaxTechCompliance()
            : base()
        {
        }
        #endregion
        #region 
        #region 
        public override ICompliance CreateNew()
        {
            return new MaxTechCompliance();
        }
        protected override void StartInternal()
        {
            this._settings.OperatingModes.NoFines               = true;
            this._settings.OperatingModes.IgnoreYearAvailable   = true;
            this._settings.OperatingModes.IgnorePhaseIn         = true;
            this._settings.OperatingModes.IgnoreRefreshRedesign = true;
            base.StartInternal();
        }
        #endregion
        #endregion
	}
}

